Ruby - Feature #19328

Please bring back the use of Hash objects for keyword arguments
01/09/2023 08:31 PM - randallcoding (Randall Coding)

Status: Rejected
Priority: Normal
Assignee:

Target version:

Description

The change in 3.0 (linked here
https://www.ruby-lang.org/en/news/2019/12/12/separation-of-positional-and-keyword-arguments-in-ruby-3-0/) no longer automatically
converts Hash objects into keyword arguments. This takes Ruby away from what it has always been about: being as intuitive and
developer friendly as possible.

The solution given to make a hash into keywords is to perform a double splat (**) on the hash object. This is confusing and esoteric,
not to mention will require a lot of old code to be re-written.

For example | have code that was written like this
def Foo(a:, b:)

puts a + b
end

which | can call by simply using

myhash = {a:3, b:5}
Foo (myhash)

Look at the clarity, simplicity and convenience. The interpreter takes care of the messy and unnecessary bits and our code is easily
understandable by other humans.

But now for the same function we need to write
Foo (**myhash)

We have to add superficial extra strokes (from the human perspective) to achieve what our intelligent interpreter once knew we
wanted with less hassle.

Let's not become like those other language! Please keep Ruby intuitive, convenient and developer friendly and make this feature
what is was before.

History

#1 - 01/09/2023 08:45 PM - randallcoding (Randall Coding)
- Description updated
#2 - 01/09/2023 08:50 PM - jeremyevans0 (Jeremy Evans)
Considering:
e That separating keyword and positional arguments was done for good reasons (as explained in the
"Why we're deprecating the automatic conversion" section of the page you linked to),
® That reverting the change would reintroduce all of the previous problems that Ruby 2 keyword arguments had,
e That the separation happened 3 released versions ago and is now well established, and
¢ That the vast majority of gems have upgraded to support keyword argument separation,
| estimate that this feature request has a 0% change of approval.
#3 - 01/09/2023 09:05 PM - randallcoding (Randall Coding)

jeremyevans0 (Jeremy Evans) wrote in #note-2:

is now well established

11/14/2025 1/2



https://www.ruby-lang.org/en/news/2019/12/12/separation-of-positional-and-keyword-arguments-in-ruby-3-0/

Many developers are working on legacy systems that aren't immediately up to date with the latest version of ruby. To imply this is "established"
across the entire community is misleading. | didn't have a single client using rails 3.0 or greater until this week.

for good reasons

| don't think the edge case given is good reason to remove commonly used and well made Ruby functionality. It is not worth the trade off. | suggest
handling the edge case specifically and retain the original quality of the previous feature.

| estimate that this feature request has a 0% change of approval.
| want to make my voice heard regardless of the likelihood of a change. And also, it is never too late to correct a mistake.

#4 - 01/09/2023 11:34 PM - Eregon (Benoit Daloze)
- Status changed from Open to Rejected

This would mean breaking code working on 3.0/3.1/3.2, of course that's not acceptable.
Adding ** there is not a big deal and it makes a lot of sense once you understand keyword arguments are now separated from positional arguments.
